<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.14"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>MAiNGO Reader Writer Utility: MAiNGO Reader Writer Manual</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">MAiNGO Reader Writer Utility
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.14 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">MAiNGO Reader Writer Manual </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><dl class="section author"><dt>Authors</dt><dd>Dominik Bongartz, Jaromił Najman, Susanne Sass, Alexander Mitsos </dd></dl>
<dl class="section copyright"><dt>Copyright</dt><dd>Process Systems Engineering (AVT.SVT), RWTH Aachen University </dd></dl>
<dl class="section date"><dt>Date</dt><dd>12.06.2020</dd></dl>
<p><br />
 </p>
<h1><a class="anchor" id="intro_sec"></a>
Introduction</h1>
<p>Welcome to MAiNGO! If you have any issues, concerns, or comments, please communicate them using the "Issues" functionality in GitLab or write an e-mail to <a href="#" onclick="location.href='mai'+'lto:'+'MAi'+'NG'+'O@a'+'vt'+'.rw'+'th'+'-aa'+'ch'+'en.'+'de'; return false;">MAiNG<span style="display: none;">.nosp@m.</span>O@av<span style="display: none;">.nosp@m.</span>t.rwt<span style="display: none;">.nosp@m.</span>h-aa<span style="display: none;">.nosp@m.</span>chen.<span style="display: none;">.nosp@m.</span>de</a>.</p>
<p><br />
 </p>
<h2><a class="anchor" id="what_is_sec"></a>
What is the MAiNGO Reader Writer utility?</h2>
<p>The MAiNGO Reader Writer utility is a seperate tool, that can be used to write an ALE problem.txt or a MAiNGO problem.h file out of a GAMS convert file. In order to generate a GAMS convert file, you have to set your solver to convert and execute the solution process in GAMS. In general, this generates a gams.gms file which then can be used as input for the MAiNGO Reader Writer utility. It is also possible to translate whole folders of GAMS convert files. If you additionally provide the GAMS dictionary file (<code>dict.txt</code>), this tool will rename the default GAMS convert variables to your original ones.</p>
<p>The MAiNGO Reader Writer utility can also be used to read information such as time needed, number of iterations or the final lower bound from MAiNGO log files. This can be useful when one wants to automatically process many log files and, e.g., generate tables automatically.</p>
<p><br />
 </p>
<h2><a class="anchor" id="compiling"></a>
Which compiliers are supported?</h2>
<p>The MAiNGO Reader Writer utility has been successfully tested for GCC and Visual Studio compilers. <br />
 The Intel compiler currently does not support the C++17 <code>filesystem</code> package making a compilation of the MAiNGO Reader Writer tool not possible.</p>
<p><br />
 </p>
<h2><a class="anchor" id="usage"></a>
How to use the MAiNGO Reader Writer utility?</h2>
<p>After generating and compiling the project, first take a look into the main.cpp. Here you see how to <a class="el" href="classmaingo_1_1reader_writer_1_1_m_ai_n_g_o_reader_writer.html#a483e97f491ed1ec3ba30b9416e17138f">read a GAMS convert file</a>. You can either specify the path to the GAMS convert file in the main.cpp by replacing the gamsFile string or by directly calling the MAiNGOReaderWriter.exe with an additional command line argument specifiying the path to your GAMS convert file. You can also <a class="el" href="classmaingo_1_1reader_writer_1_1_m_ai_n_g_o_reader_writer.html#a974e83a9236076a342791cd6d0f9e85c">print the information about the currently read GAMS file</a>. Note that reading in a new GAMS file overrides all internal information about the problem.</p>
<p>After reading the GAMS convert file, you can either <a class="el" href="classmaingo_1_1reader_writer_1_1_m_ai_n_g_o_reader_writer.html#adfd584ea821b9efa7441c084e9d5705a">write an ALE problem.txt file</a> or <a class="el" href="classmaingo_1_1reader_writer_1_1_m_ai_n_g_o_reader_writer.html#a8c61d0c87421db0912d31f3b79314a3b">write a MAiNGO problem.h file</a> out of the lastly read in GAMS convert file. This enables the translation of GAMS convert files to MAiNGO specific input files. Please note that a direct way of using GAMS convert files as input for MAiNGO represents one of the works in progress.</p>
<p>Please note that it is possible to directly translate multiple GAMS convert files to <a class="el" href="classmaingo_1_1reader_writer_1_1_m_ai_n_g_o_reader_writer.html#af20b0cf08b2741e07e57de1d7a130d43">MAiNGO problem files</a> or <a class="el" href="classmaingo_1_1reader_writer_1_1_m_ai_n_g_o_reader_writer.html#ae834a7bcc749ec79410a278151c50978">ALE problem files</a>.</p>
<p>Furthermore, the MAiNGO Reader Writer utility can be used to <a class="el" href="classmaingo_1_1reader_writer_1_1_m_ai_n_g_o_reader_writer.html#a7d9f98c5950d309c4094c601f62223bd">read MAiNGO log files</a> in order to process the information further and, e.g., write a table. It is also possible to <a class="el" href="classmaingo_1_1reader_writer_1_1_m_ai_n_g_o_reader_writer.html#af78062e5ea1cf2effa0fcd1d6882dadc">print the information read from a MAiNGO log file</a>. </p>
</div></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.14
</small></address>
</body>
</html>
